ChangeSet 1.781.21.10, 2002/10/15 15:28:49-07:00, ddstreet@ieee.org

[PATCH] uhci: remove qh from qh->list

I think the qh needs to be removed from its qh->list, or else
uhci_remove_qh will incorrectly change the previous endpoint's qh->link,
undoing what was just done in uhci_delete_queued_urb.


diff -Nru a/drivers/usb/host/uhci-hcd.c b/drivers/usb/host/uhci-hcd.c
--- a/drivers/usb/host/uhci-hcd.c	Fri Oct 18 14:43:34 2002
+++ b/drivers/usb/host/uhci-hcd.c	Fri Oct 18 14:43:34 2002
@@ -622,6 +622,7 @@
 		pqh->link = cpu_to_le32(nurbp->qh->dma_handle) | UHCI_PTR_QH;
 
 		list_add_tail(&nurbp->qh->list, &urbp->qh->list);
+		list_del_init(&urbp->qh->list);
 	} else {
 		/* We're somewhere in the middle (or end). A bit trickier */
 		/*  than the head scenario */
